% Beavise theme by Floris De Feyter, based on:
% kuleuventheme2 by Janez Kren, September 2017, janez.kren@kuleuven.be

\mode<presentation>

\def\logofile{theme/kul_eavise.pdf}

\def\sedes{n}  % if no option: title pages (default)
\DeclareOptionBeamer{no}{\def\sedes{n}}  % normal title
\DeclareOptionBeamer{sedes}{\def\sedes{y}}  % title pages with sedes
\DeclareOptionBeamer{icon}{\def\sedes{i}}  % title pages with sedes

\DeclareOptionBeamer{white}{\def\bgcolor{white}}  % white title

\def\poster{n} % Default: no poster
\DeclareOptionBeamer{poster}{\def\poster{y}} % Use poster formatting

\ProcessOptionsBeamer
\newlength\baseh %base size
\setlength{\baseh}{0.072\paperheight\relax}  % adjust coefficent to rescale


% Packages
\usepackage{tikz}
\usetikzlibrary{shapes,calc,fit}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[sfdefault]{roboto}
\newenvironment{robothin}{\fontfamily{Roboto-LF}\fontseries{t}\selectfont}{\par}
\newenvironment{robolight}{\fontfamily{Roboto-LF}\fontseries{l}\selectfont}{\par}
\usepackage{xparse}
\usepackage{xkeyval}
\usepackage{etoolbox}
\usepackage{ifthen}

%%		
%%  COLOURS and FONT STYLES
%%

% Default theme colours
\definecolor{kul-blue}		{RGB}{29,141,176}		%KUL blue (primair blauw)
\definecolor{kul-secblue}	{RGB}{220,231,240}		%KUL light gray-blue (secundair blauw)
\definecolor{kul-dark}		{RGB}{47,77,93}			%KUL dark blue 
\definecolor{kul-light}		{RGB}{82,189,236}		%KUL light blue 

\definecolor {kul-logo1}	{RGB}		{0,   64,  122}	% KUL logo dark blue
\definecolor {kul-logo2}	{RGB}		{82,  189, 236}	% KUL logo light blue

\definecolor {kul-blue1}	{RGB}		{31,  171, 231}	% KUL primary blue
\definecolor {kul-blue2}	{RGB}		{29,  141, 176}	% KUL secondary blue
\definecolor {kul-blue3}	{RGB} 	{17,  110, 138} % KUL tertiary blue
\definecolor {kul-orange}	{RGB}		{221, 138, 46}	% KUL orange (hover/accent color)

\definecolor {gray}				{gray}	{.5}						% Gray
\definecolor {lgray}			{gray}	{.94}						% Light gray
\definecolor {bgray}			{RGB}		{220,231,240}		% Blue gray (footer)

% Semantic colour definitions
\colorlet {headerbg}				{kul-logo1}
\colorlet {footerbg}				{bgray}
\colorlet {framebg}					{white}

\colorlet {textfg}					{kul-logo1}
\colorlet {linkfg}					{kul-logo2}
\colorlet {bulletfg}				{textfg}

\colorlet {blockbg}					{lgray}
\colorlet {blocktitlefg}		{kul-logo2}
\colorlet {alerttitlefg}		{kul-orange}
\colorlet {exampletitlefg}	{kul-blue2}
\colorlet {buttonbg}				{kul-orange}
\colorlet {buttonfg}				{framebg}

% Text colours
\hypersetup{colorlinks,linkcolor=linkfg,urlcolor=linkfg}
\urlstyle{sf}

\setbeamercolor{normal text}						{fg=textfg}
\setbeamercolor{frametitle}							{fg=kul-logo2}
\setbeamercolor{background canvas}			{bg=framebg}
\setbeamercolor{section in toc}					{fg=textfg}
\setbeamercolor{section in toc shaded}	{fg=textfg}
\setbeamercolor{item}										{fg=bulletfg}
\setbeamercolor{subitem}								{fg=bulletfg}
\setbeamercolor{subsubitem}							{fg=bulletfg}
\setbeamercolor{text}										{fg=white,bg=textfg}
\setbeamercolor{caption name}						{fg=textfg}
\setbeamercolor{abstract title}					{fg=linkfg}

% Blocks, theorem-like environments and colorboxes
\setbeamerfont{block title}						{size=\normalsize}
\setbeamercolor{block title}					{bg=blockbg,fg=blocktitlefg}
\setbeamercolor{block body}						{bg=blockbg,fg=textfg}
\setbeamertemplate{qed symbol}				{\color{blocktitlefg} $\square$}
\setbeamercolor{block title alerted}	{bg=blockbg,fg=alerttitlefg}
\setbeamercolor{block body alerted}		{bg=blockbg,fg=textfg}
\setbeamercolor{block title example}	{bg=blockbg,fg=exampletitlefg}
\setbeamercolor{block body example}		{bg=blockbg,fg=textfg}
\setbeamercolor{button}								{bg=buttonbg,fg=buttonfg}

\setbeamercolor{boxheader}	{fg=white,bg=headerbg}
\setbeamercolor{boxfooter}	{fg=textfg,bg=footerbg}
\setbeamercolor{boxinvert}	{fg=framebg,bg=textfg}
\setbeamercolor{box1}				{fg=white,bg=kul-blue1}
\setbeamercolor{box2}				{fg=white,bg=kul-blue2}
\setbeamercolor{box3}				{fg=white,bg=kul-blue3}
\setbeamercolor{box4}				{fg=white,bg=kul-orange}

%%		
%%  BEAMER TEMPLATE SETTINGS
%%
\setbeamertemplate{sections/subsections in toc}[sections numbered]
\setbeamersize{text margin left=34pt,text margin right=34pt}

%itemize list
\setbeamertemplate{itemize item}[circle]
\setbeamertemplate{itemize subitem}{-}
\renewcommand\textbullet{\ensuremath{\bullet}}
\setbeamertemplate{itemize subsubitem}{-}

%enumerate list
\setbeamertemplate{enumerate item}{\small \insertenumlabel \enspace}
\setbeamertemplate{enumerate subitem}{\scriptsize \raisebox{.085em} \insertsubenumlabel}
\setbeamertemplate{enumerate subsubitem}{\tiny \raisebox{.18em} \insertsubsubenumlabel}

\setbeamertemplate{navigation symbols}{}

%%%
% KEYWORDS ARGS FOR \setheaderimg and \setheadercolor
%%%
\makeatletter
\define@key{bgimg}{image}[]{% header image
	\ifstrempty{#1}{\undef\bgimage}{\def\bgimage{#1}}
}
\define@boolkey{bgimg}{onlyfull}[false]{% Don't show image in headers
	\ifthenelse{\equal{#1}{true}}
	{\def\bgonlyfull{}}
	{\undef\bgonlyfull}%
}
\define@key{bgimg}{vshift}[0pt]{% Vertical shift of the background image
	\def\bgvshift{#1}
}
\define@key{bgimg}{hshift}[0pt]{% Horizontal shift of the background image
	\def\bghshift{#1}
}
\define@key{bgimg}{zoom}[1]{% Zoom factor for the background image
	\def\bgzoom{#1}
}

\define@key{fgcolor}{color}[headerbg]{% Overlay color
	\def\fgcolor{#1}
}
\define@key{fgcolor}{alpha}[0.85]{% Opacity of the color overlay
	\def\fgalpha{#1}
}
\define@key{fgcolor}{textcolor}[white]{% Text color on overlay
	\def\fgtextcolor{#1}
}

\define@key{bgcolor}{color}[framebg]{% Overlay color
	\def\bgcolor{#1}
}
\define@key{bgcolor}{alpha}[1]{% Opacity of the color overlay
	\def\bgalpha{#1}
}
\makeatother

%%%
% MAKE COMMANDS AND LOAD DEFAULT VALUES
%%%
\presetkeys{bgimg}{%
	image,onlyfull,vshift,hshift,zoom
}{}
\presetkeys{fgcolor}{%
	color,alpha,textcolor
}{}
\presetkeys{bgcolor}{%
	color,alpha
}{}
\newcommand\setheaderimg[1]{%
	\setkeys{bgimg}{#1}
}
\newcommand\setheadercolor[1]{%
	\setkeys{fgcolor}{#1}
}
\newcommand\setbgcolor[1]{%
	\setkeys{bgcolor}{#1}
}
% Load the defaults
\setheaderimg{}
\setheadercolor{}
\setbgcolor{}

%%		
%%  TITLE PAGE
%%
\setbeamertemplate{title page}
{%
	\hyphenpenalty=10000
	\begin{tikzpicture}[remember picture,overlay]
		% check if a main image has been defined
		% if so, make the overlays slightly transparant
		% title graphic (optional)
		\node
		[anchor=north east,inner sep=0pt, xshift=\bghshift, yshift=\bgvshift] 
		at (current page.north east) 
		{\ifdef{\bgimage}{\includegraphics[width=\bgzoom\paperwidth]{\bgimage}}{}};

		% blue background mono fill
		\node (bgfill)
		[fill, fill=\fgcolor, fill opacity=\ifdef{\bgimage}{\fgalpha}{1},
		minimum width=\paperwidth, minimum height=\paperheight, anchor=south west, outer sep=0pt]
    at (current page.south west)
		{};

		% invisible header footer
		\node (header)
		[minimum width=\paperwidth,minimum height=0.22\paperheight, anchor=south west, outer sep=0pt] 
		at (current page.south west)
		{};

		% KUL-eavise logo
		\node
		[anchor=east, xshift=-.03\paperwidth,inner sep=0pt] 
		at (header.east) 
		{\includegraphics[height=.1\paperheight]{\logofile}};

		% authors, institute, date
		\node
		[anchor=west, xshift=.03\paperheight, text width=.5\paperwidth,
		\fgtextcolor, opacity=0.75, font=\fontsize{12pt}{14pt}\selectfont]
		at (header.west) 
		{\insertauthor \\ \insertinstitute \\ \insertdate \\};	

		% title + subtitle centered between page north and header north
		\node
		[anchor=center, align=center, \fgtextcolor, text width=.8\paperwidth]
		at ($(current page.north)!.5!(header.north)$)
		{%
			\begin{robolight}
				\fontsize{24pt}{24pt}\selectfont
				\inserttitle\\
			\end{robolight}
			\begin{robothin}
				\fontsize{18pt}{24pt}\selectfont
				\insertsubtitle\\
			\end{robothin}
		};
	\end{tikzpicture}
}

%head frametitle	
\setbeamertemplate{frametitle}
{%
	\hyphenpenalty=10000
	\begin{tikzpicture}[remember picture,overlay]
		% frame title
        \if y\poster
            \def\talign{left}
            \def\tanchor{west}
            \def\tat{banfg.west}
            \ifdim\paperwidth<\paperheight
                \def\fsize{0.6\baseh}
                \def\ilsize{0.4\baseh}
                \def\twidth{0.95\paperwidth}
            \else
                \def\fsize{0.9\baseh}
                \def\ilsize{0.65\baseh}
                \def\twidth{0.75\paperwidth}
            \fi
        \else
            \def\fsize{24pt}
            \def\ilsize{20pt}
            \def\talign{center}
            \def\tanchor{center}
            \def\tat{banfg.center}
            \def\twidth{0.95\paperwidth}
        \fi
        \begin{robolight}
            \node
                (frametitle)
                [\fgtextcolor, anchor=\tanchor, align=\talign, text
                width=\twidth, inner sep=0pt, outer sep=.1\baseh]
                at (\tat)
                {%
                    \fontsize{\fsize}{\ilsize}\selectfont
                    \textsc{\insertframetitle\\}
                };
        \end{robolight}
	\end{tikzpicture}
}

\setbeamertemplate{headline}{
    \begin{tikzpicture}[remember picture,overlay]
        \if y\poster
            \ifdim\paperwidth<\paperheight
                \def\banhfac{0.12}
            \else
                \def\banhfac{0.15}
            \fi
        \else
            \def\banhfac{0.2}
        \fi

        % main background
        \fill [color=\bgcolor]
            (current page.north west) rectangle (current page.south east);

		\node (banbg)
		[anchor=north west, rectangle, minimum width=\paperwidth, minimum
        height=\banhfac\paperheight, inner sep=0pt, outer sep=0pt,
		path picture={%
			\node
			[inner sep=0pt, anchor=center, yshift=\bgvshift, xshift=\bghshift]
			at (path picture bounding box.center)
			{\ifdef{\bgonlyfull}{}{\ifdef{\bgimage}{%
			\includegraphics[width=\bgzoom\paperwidth]{\bgimage}}{}}};
		}] 
		at (current page.north west) 
		{};

		% header overlay
		\node (banfg)
		[fill, fill=\fgcolor, fit={(banbg.north west) (banbg.south east)},
         anchor=north west, opacity=\ifdef{\bgonlyfull}{1}{\ifdef{\bgimage}{\fgalpha}{1}},
         inner sep=0pt, outer sep=0pt] 
		at (current page.north west)
		{};

        \if y\poster
            % KUL logo on poster
            \ifdim\paperwidth<\paperheight
                % Portrait poster
                \node
                (logo)
                [anchor=south east, inner sep=.1\baseh] 
                at (banbg.south east) 
                {\includegraphics[width=.2\paperwidth]{\logofile}};
            \else%
                % Landscape poster
                \node
                (logo)
                [anchor=east,xshift=-0.5\baseh, inner sep=0pt, outer sep = 0pt] 
                at (banbg.east) 
                {\includegraphics[width=.3\paperheight]{\logofile}};
            \fi%
        \else
        \fi

        % info box on poster
        \if y\poster
        \node
            [white, align=left, text width=.75\paperwidth,
            anchor=south west, inner sep=0pt, outer sep=0pt,
            yshift=.1\baseh, xshift=.1\baseh]
            at (banbg.south west) 
            {%
                \begin{robothin}
                    \fontsize{0.015\paperheight}{0.02\paperheight}\selectfont
                    \textsc{\insertauthor \quad\insertinstitute \quad\insertdate}
                \end{robothin}
            };	
        \else
        \fi
    \end{tikzpicture}	

    % Sedes on poster
    \if y\poster
        \if y\sedes 
            \begin{tikzpicture}[remember picture,overlay]
                \node [anchor=south east,inner sep=0pt,opacity=0.25] 
                    at (current page.south east) 
                    {\includegraphics[height=3.333\baseh]{theme/sedes.png} };
            \end{tikzpicture}
        \else
            \if i\sedes 
            \begin{tikzpicture}[remember picture,overlay]
                \node [anchor=south east, shift={(.5\baseh, -.5\baseh)}, inner sep=0pt,opacity=0.25] 
                    at (current page.south east) 
                    {\includegraphics[height=3.333\baseh]{theme/icon_eavise.pdf} };
            \end{tikzpicture}
            \else
            \fi
        \fi
    \else
    \fi

    \if y\poster
        \ifdim\paperwidth<\paperheight
            \vspace{0.1\paperheight}
        \else
            \vspace{0.15\paperheight}
        \fi
    \else
        \vspace{0.15\paperheight}
    \fi
}

%footline
\defbeamertemplate{footline}{body}
{%
	\hypersetup{hidelinks} %disable link colors
	\begin{tikzpicture}[remember picture,overlay]
		% blue background rectangle
		\node (header)
		[fill,fill=footerbg,minimum width=\paperwidth, minimum height=.1\paperheight,anchor=south west, outer sep=0pt] 
		at (current page.south west)
		{};

		% section title
		\node
		[textfg,anchor=west,xshift=.1\paperheight, text depth=0pt] 	
		at (header.west)
		{\scriptsize \insertsection};

		% slide number
		\node
		[textfg, anchor=east,xshift=-.05\paperwidth, text depth=0pt] 	
		at (header.east)
		{\scriptsize \insertframenumber};
	\end{tikzpicture}
}	



%%		
%%  SECTION START
%%
\AtBeginSection[]
{%
	\hyphenpenalty=10000
	\begin{frame}[plain]
		\begin{tikzpicture}[remember picture,overlay]
			% background image (optional)
			\node
			[anchor=north east,inner sep=0pt, xshift=\bghshift, yshift=\bgvshift] 
			at (current page.north east) 
			{\ifdef{\bgimage}{\includegraphics[width=\bgzoom\paperwidth]{\bgimage}}{}};

			% blue background mono fill
			\fill [color=\fgcolor, opacity=\ifdef{\bgimage}{\fgalpha}{1}]
			(current page.south east) rectangle (current page.north west);

			\node (secnum)
			[\fgtextcolor,anchor=south west,xshift=.05\paperwidth, yshift=.1\paperheight, text depth=0pt] 	
			at (current page.south west)
			{\begin{robothin}\fontsize{144pt}{0}\selectfont\insertsectionnumber\end{robothin}};

			\node
			[\fgtextcolor,anchor=south west, text width=.6\paperwidth, align=left, font=\fontsize{36pt}{30pt}\selectfont]
			at (secnum.south east) 
			{%
				\hypersetup{hidelinks}%
				\begin{robolight}%
					\textsc{\insertsection\\}
				\end{robolight}
			};
		\end{tikzpicture}
	\end{frame}
}

%%
%% TOC frame
%%
%% Shows the Table of Contents of the current slideshow
%%
\newcommand{\tocframe}[1]{%
	\begin{frame}{#1}
		\vspace{-20pt}
		% Change ToC line spacing
		\fontsize{14}{10}\selectfont
		\hypersetup{hidelinks}
		\tableofcontents
	\end{frame}
}

%%
%% Single-title frame
%%
%% Shows either the main image, the current section image or just the default
%% background color with an optional text centered on top.
%%
\newcommand{\fullimageframe}[1]
{%
	\hyphenpenalty=10000
	\begin{frame}[plain]
		\begin{tikzpicture}[remember picture,overlay]
			\node
			[anchor=north east, inner sep=0pt]
			at (current page.north east)
			{\ifdef{\bgimage}{\includegraphics[width=\bgzoom\paperwidth]{\bgimage}}{}};

			\node
			[fill, fill=\fgcolor, fill opacity=\ifdef{\bgimage}{\fgalpha}{1},
			minimum width=\paperwidth, minimum height=\paperheight,
			anchor=south west, outer sep=0pt]
			at (current page.south west)
			{};

			\node
			[anchor=center, inner sep=0pt]
			at (current page.center)
			{
				\begin{robothin}
					\textcolor{\fgtextcolor}{\huge{#1}}
				\end{robothin}
			};
		\end{tikzpicture}
	\end{frame}
}

\mode<all> 
